<?xml version="1.0"?>
<!--
/**
 * @author Amasty Team
 * @copyright Copyright (c) 2021 Amasty (https://www.amasty.com)
 * @package Amasty_PreOrderAnalytic
 */
-->

<config xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:noNamespaceSchemaLocation="urn:magento:framework:ObjectManager/etc/config.xsd">
    <type name="Amasty\PreOrderAnalytic\Model\GetAnalyticCounter">
        <arguments>
            <argument name="getAnalyticCounterPool" xsi:type="array">
                <item name="preorder_pending" xsi:type="object">Amasty\PreOrderAnalytic\Model\GetAnalyticCounter\GetCountPendingPreorders</item>
                <item name="preorder_placed" xsi:type="object">Amasty\PreOrderAnalytic\Model\GetAnalyticCounter\GetCountPlacedPreorders</item>
                <item name="preorder_item" xsi:type="object">Amasty\PreOrderAnalytic\Model\GetAnalyticCounter\GetCountPreorderProducts</item>
                <item name="preorder_customer" xsi:type="object">Amasty\PreOrderAnalytic\Model\GetAnalyticCounter\GetUniquePreorderCustomers</item>
            </argument>
        </arguments>
    </type>

    <type name="Magento\Sales\Controller\Adminhtml\Order\Index">
        <plugin name="Amasty_PreOrderAnalytic::addPreorderFilter" type="Amasty\PreOrderAnalytic\Plugin\Sales\Controller\Adminhtml\Order\Index\AddPreorderFilter" />
    </type>

    <type name="Amasty\PreOrderAnalytic\Model\Config\Backend\Order\Status">
        <arguments>
            <argument name="data" xsi:type="array">
                <item name="order_config" xsi:type="object">Magento\Sales\Model\Order\Config\Proxy</item>
            </argument>
        </arguments>
    </type>

    <virtualType name="Amasty\PreOrderAnalytic\Model\Config\Backend\Order\PendingStatus" type="Amasty\PreOrderAnalytic\Model\Config\Backend\Order\Status">
        <arguments>
            <argument name="data" xsi:type="array">
                <item name="default_states" xsi:type="array">
                    <item name="0" xsi:type="const">\Magento\Sales\Model\Order::STATE_NEW</item>
                    <item name="1" xsi:type="const">\Magento\Sales\Model\Order::STATE_PENDING_PAYMENT</item>
                    <item name="2" xsi:type="const">\Magento\Sales\Model\Order::STATE_PROCESSING</item>
                    <item name="3" xsi:type="const">\Magento\Sales\Model\Order::STATE_PAYMENT_REVIEW</item>
                </item>
            </argument>
        </arguments>
    </virtualType>

    <virtualType name="Amasty\PreOrderAnalytic\Model\Config\Backend\Order\RevenueStatus" type="Amasty\PreOrderAnalytic\Model\Config\Backend\Order\Status">
        <arguments>
            <argument name="data" xsi:type="array">
                <item name="default_states" xsi:type="array">
                    <item name="0" xsi:type="const">\Magento\Sales\Model\Order::STATE_COMPLETE</item>
                </item>
            </argument>
        </arguments>
    </virtualType>
</config>
